package cn.iocoder.yudao.module.system.service.houselocation;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.system.controller.admin.houselocation.vo.*;
import cn.iocoder.yudao.module.system.dal.dataobject.houselocation.WareHouseLocationDO;
import com.baomidou.mybatisplus.extension.service.IService;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.util.List;

/**
 * 库位 Service 接口
 *
 * @author 陈宾顺
 */
public interface HouseLocationService extends IService<WareHouseLocationDO> {

    /**
     * 创建库位
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createHouseLocation(@Valid WareHouseLocationSaveReqVO createReqVO);

    /**
     * 更新库位
     *
     * @param updateReqVO 更新信息
     */
    void updateHouseLocation(@Valid WareHouseLocationSaveReqVO updateReqVO);

    /**
     * 删除库位
     *
     * @param id 编号
     */
    void deleteHouseLocation(Long id);

    /**
     * 获得库位
     *
     * @param id 编号
     * @return 库位
     */
    WareHouseLocationDO getHouseLocation(Long id);

    /**
     * 获得库位分页
     *
     * @param pageReqVO 分页查询
     * @return 库位分页
     */
    PageResult<WareHouseLocationDO> getHouseLocationPage(WareHouseLocationPageReqVO pageReqVO);

    /**
     * 库位批量保存或修改或删除
     *
     * @param positionMapId
     * @param list
     */
    void batchSaveOrEditOrDel(Long positionMapId, List<List<WareHouseLocationDO>> list);

    /**
     * 根据地图查询库位
     *
     * @param positionMapId
     * @return
     */
    List<WareHouseLocationDO> getByMapId(Long positionMapId);

    /**
     * @param requestVO
     * @return
     */
    List<WareHouseLocationRespVO> getLocationByName(WareHouseLocationVO requestVO);

    /**
     * 根据地图id 点位id 获取库位信息
     *
     * @param mapId
     * @param mapItemId
     * @return
     */
    List<WareHouseLocationDO> getByMapItemId(Long mapId, Long mapItemId);

    /**
     * 根据编号查询库位
     * @param locationNumbers
     * @return
     */
    List<WareHouseLocationDO> getLocationByLocationNumbers(List<Long> locationNumbers);

    /**
     * 更新线库名称
     * @param laneId
     * @param laneName
     */
    void updateLocationLaneNameByLaneId(Long laneId, String laneName);

    /**
     * 设置线库名称和id为空
     * @param id
     */
    void updateLocationLaneNameEmptyByLaneId(Long laneId);

    /**
     * 批量更新库位
     * @param list
     */
    void updateHouseLocationList(List<WareHouseLocationSaveReqVO> list);

    /**
     * 设置库区名称和id为空
     * @param id
     */
    void updateLocationAreaNameEmptyByAreaId(Long areaId);

    /**
     * 获取这个地图对应的库位和坐标信息
     * @param mapId
     * @return
     */
    List<WareHouseLocationItemRespVO> getLocationsXYByMapId(Long mapId);

    /**
     * 根据地图id删除
     * @param mapId
     */
    void deleteHouseLocationByMapId(Long mapId);

    List<WareHouseLocationDO> getInStockLockLocationByMapId(Long mapId);
}
